<?php 
namespace Concrete\Package\JbMegamenu;

//use \Concrete\Core\Cache\CacheLocal as Cache;
use CacheLocal;
use Concrete\Core\Attribute\Key\CollectionKey as CollectionAttributeKey;
//use Concrete\Core\Entity\Attribute\Key\PageKey as CollectionAttributeKey;
use Core;
use Package;
use BlockType;
use SinglePage;
use Loader;
use View;
use Log;
use Concrete\Core\Backup\ContentImporter;

class Controller extends Package {

	protected $pkgHandle = 'jb_megamenu';
	protected $appVersionRequired = '5.7.5.2';
	protected $pkgVersion = '1.6.2.2';
	
	public function getPackageDescription() {
		return t("Multi-level navigation menu with hamburger support.");
	}
	
	public function getPackageName() {
		return t("Mega Menu");
	}
	
	public function upgrade() {
		$pkg = parent::upgrade();
		$this->configure($pkg); 
		return $pkg;
	}
	
	public function install() {
		$pkg = parent::install();
		
		// install block		
		BlockType::installBlockTypeFromPackage('jb_megamenu', $pkg);
		
		$this->configure($pkg);
	}
	
	public function configure($pkg){ 
		$this->insert_attributes($pkg);
		/*
		Loader::model('collection_attributes');
		$replaceLinkAttrKey=CollectionAttributeKey::getByHandle('hide_children_from_megamenu');
		if( !is_object($replaceLinkAttrKey) ){
			CollectionAttributeKey::add('hide_children_from_megamenu', t('Hide Children from Mega Menu'), true, null, 'BOOLEAN');
		}
		$replaceLinkAttrKey=CollectionAttributeKey::getByHandle('replace_link_with_first_in_nav');
		if( !is_object($replaceLinkAttrKey) ){
			CollectionAttributeKey::add('replace_link_with_first_in_nav', t('Replace link with first child in Mega Menu'), true, null, 'BOOLEAN');
		}
		$replaceLinkAttrKey=CollectionAttributeKey::getByHandle('replace_link_with_parent_nav');
		if( !is_object($replaceLinkAttrKey) ){
			CollectionAttributeKey::add('replace_link_with_parent_nav', t('Replace link with parent page in Mega Menu'), true, null, 'BOOLEAN');
		}
		
		$dontLinkAttrKey=CollectionAttributeKey::getByHandle('dont_link');
		if( !is_object($dontLinkAttrKey) ){
			CollectionAttributeKey::add('dont_link', t('Dont Link in Navigation'), true, null, 'BOOLEAN');
		}
		
		$accesskeyAttrKey=CollectionAttributeKey::getByHandle('megamenu_accesskey');
		if( !is_object($accesskeyAttrKey) ){
			CollectionAttributeKey::add('megamenu_accesskey', t('Mega Menu access key'), false, null, 'TEXT');
		}
		*/
		
	}
	
	public function insert_attributes($pkg) {
		$ci = new ContentImporter();
        $ci->importContentFile($this->getPackagePath() . '/install/content_attributes.xml');
	}
	
	public function uninstall(){
		return parent::uninstall();
	}

}
